## scotch 6.1.3

=== src/Makefile ===
## Copyright 2004,2007,2008,2010-2012,2014,2018-2020 IPB, Universite de Bordeaux, INRIA & CNRS
##
## This file is part of the Scotch software package for static mapping,
## graph partitioning and sparse matrix ordering.
##
## This software is governed by the CeCILL-C license under French law
## and abiding by the rules of distribution of free software. You can
## use, modify and/or redistribute the software under the terms of the
## CeCILL-C license as circulated by CEA, CNRS and INRIA at the following
## URL: "http://www.cecill.info".
## 
## As a counterpart to the access to the source code and rights to copy,
## modify and redistribute granted by the license, users are provided
## only with a limited warranty and the software's author, the holder of
## the economic rights, and the successive licensors have only limited
## liability.
## 
## In this respect, the user's attention is drawn to the risks associated
## with loading, using, modifying and/or developing or reproducing the
## software by the user in light of its specific status of free software,
## that may mean that it is complicated to manipulate, and that also
## therefore means that it is reserved for developers and experienced
## professionals having in-depth computer knowledge. Users are therefore
## encouraged to load and test the software's suitability as regards
## their requirements in conditions enabling the security of their
## systems and/or data to be ensured and, more generally, to use and
## operate it in the same conditions as regards security.
## 
## The fact that you are presently reading this means that you have had
## knowledge of the CeCILL-C license and that you accept its terms.
##

VERSION	= 6
RELEASE = 1
PATCHLEVEL = 3

.PHONY				:	clean	default	install	ptscotch	realclean	required	scotch

default				:	scotch

required			:	Makefile.inc	../bin	../include	../lib

Makefile.inc			:
					@echo "#####################################################################"
			        	@echo "BEFORE COMPILING Scotch OR PT-Scotch, YOU SHOULD HAVE AN APPROPRIATE"
					@echo "Makefile.inc FILE IN THIS DIRECTORY. PLEASE LOOK INTO DIRECTORY"
	        			@echo " ./Make.inc FOR AN EXISTING Makefile.inc FILE THAT FITS YOUR NEED, OR"
		        		@echo "USE THEM AS MODELS IN CASE YOU NEED TO BUILD A NEW ONE FOR YOUR"
		        		@echo "PARTICULAR PLATFORM."
			        	@echo "#####################################################################"
			        	@echo "Then, type \"make scotch\" (default) for the sequential library"
			        	@echo "and software, or \"make ptscotch\" for the parallel library and"
			        	@echo "software."
					@exit 1

include Makefile.inc

prefix		?= /usr/local
bindir		?= $(prefix)/bin
includedir	?= $(prefix)/include
includestub     ?= include_stub
includestubdir	?= $(prefix)/$(includestub)
libdir		?= $(prefix)/lib
datarootdir	?= $(prefix)/share
mandir		?= $(datarootdir)/man

../bin				:
					-$(MKDIR) ../bin

../include			:
					-$(MKDIR) ../include

../lib				:
					-$(MKDIR) ../lib

$(bindir)			:
					-$(MKDIR) $(bindir)

$(datarootdir)			:
					-$(MKDIR) $(datarootdir)

$(includedir)			:
					-$(MKDIR) $(includedir)
					-$(MKDIR) $(includestubdir)

$(libdir)			:
					-$(MKDIR) $(libdir)

$(mandir)			:	$(datarootdir)
					-$(MKDIR) $(mandir)

$(mandir)/man1			:	$(mandir)
					-$(MKDIR) $(mandir)/man1

libscotch			:	required
					(cd libscotch ;      $(MAKE) VERSION=$(VERSION) RELEASE=$(RELEASE) PATCHLEVEL=$(PATCHLEVEL) scotch && $(MAKE) install)

scotch				:	libscotch
					(cd scotch ;         $(MAKE) VERSION=$(VERSION) RELEASE=$(RELEASE) PATCHLEVEL=$(PATCHLEVEL) scotch && $(MAKE) install)
					(cd libscotchmetis ; $(MAKE)                                                                scotch && $(MAKE) install)

libptscotch			:	libscotch
					(cd libscotch ;      $(MAKE) VERSION=$(VERSION) RELEASE=$(RELEASE) PATCHLEVEL=$(PATCHLEVEL) ptscotch && $(MAKE) ptinstall)

ptscotch			:	libptscotch
					(cd scotch ;         $(MAKE) VERSION=$(VERSION) RELEASE=$(RELEASE) PATCHLEVEL=$(PATCHLEVEL) ptscotch && $(MAKE) ptinstall)
					(cd libscotchmetis ; $(MAKE)                                                                ptscotch && $(MAKE) ptinstall)

check				:	scotch
					(cd check ; $(MAKE) check)

check_full			:	scotch
					(cd check ; $(MAKE) check_full)

ptcheck				:	ptscotch
					(cd check ; $(MAKE) ptcheck)

ptcheck_full			:	ptscotch
					(cd check ; $(MAKE) ptcheck_full)

esmumps				:	scotch
					(cd esmumps ; $(MAKE) scotch && $(MAKE) install)

escheck				:	esmumps
					(cd check ; $(MAKE) escheck)

ptesmumps			:	scotch	ptscotch
					(cd esmumps ; $(MAKE) ptscotch && $(MAKE) ptinstall)

install				:	required	$(bindir)	$(includedir)	$(libdir)	$(mandir)/man1
					-$(CP) -f ../bin/[agm]*$(EXE) $(bindir)
					-$(CP) -f ../bin/d[agm]*$(EXE) $(bindir)
					-$(CP) -f ../include/*esmumps*.h $(includedir)
					-$(CP) -f ../include/*scotch*.h $(includedir)
					-$(CP) -f ../lib/*esmumps*$(LIB) $(libdir)
					-$(CP) -f ../lib/*scotch*$(LIB) $(libdir)
					-$(CP) -f ../man/man1/*[.]1 $(mandir)/man1

installstub			:	required	$(includedir)
					-$(CP) -f ../include/*metis*.h $(includestubdir)

clean				:	required
					(cd libscotch ;      $(MAKE) clean)
					(cd scotch ;         $(MAKE) clean)
					(cd libscotchmetis ; $(MAKE) clean)
					(cd check ;          $(MAKE) clean)
					(cd esmumps ;        $(MAKE) clean)

realclean			:	required
					(cd libscotch ;      $(MAKE) realclean)
					(cd scotch ;         $(MAKE) realclean)
					(cd libscotchmetis ; $(MAKE) realclean)
					(cd check ;          $(MAKE) realclean)
					(cd esmumps ;        $(MAKE) realclean)
					-$(RM) ../bin/* ../include/* ../lib/*

=== src/check/Makefile ===
## Copyright 2011,2012,2014-2016,2018-2021 IPB, Universite de Bordeaux, INRIA & CNRS
##
## This file is part of the Scotch software package for static mapping,
## graph partitioning and sparse matrix ordering.
##
## This software is governed by the CeCILL-C license under French law
## and abiding by the rules of distribution of free software. You can
## use, modify and/or redistribute the software under the terms of the
## CeCILL-C license as circulated by CEA, CNRS and INRIA at the following
## URL: "http://www.cecill.info".
##
## As a counterpart to the access to the source code and rights to copy,
## modify and redistribute granted by the license, users are provided
## only with a limited warranty and the software's author, the holder of
## the economic rights, and the successive licensors have only limited
## liability.
##
## In this respect, the user's attention is drawn to the risks associated
## with loading, using, modifying and/or developing or reproducing the
## software by the user in light of its specific status of free software,
## that may mean that it is complicated to manipulate, and that also
## therefore means that it is reserved for developers and experienced
## professionals having in-depth computer knowledge. Users are therefore
## encouraged to load and test the software's suitability as regards
## their requirements in conditions enabling the security of their
## systems and/or data to be ensured and, more generally, to use and
## operate it in the same conditions as regards security.
##
## The fact that you are presently reading this means that you have had
## knowledge of the CeCILL-C license and that you accept its terms.
##

TMPDIR			= /tmp

SCOTCHBINDIR		= ../../bin
SCOTCHINCDIR		= ../../include
SCOTCHLIBDIR		= ../../lib
SCOTCHTGTDIR		= ../../tgt

LIBESMUMPS		= -lesmumps -lscotch -lscotcherr
LIBPTSCOTCH		= -lptscotch -lscotch -lptscotcherr
LIBSCOTCH		= -lscotchmetis -lscotch -lscotcherr

DEPESMUMPS		= $(SCOTCHLIBDIR)/libesmumps$(LIB)
DEPPTSCOTCH		= $(SCOTCHLIBDIR)/libptscotch$(LIB)
DEPSCOTCH		= $(SCOTCHLIBDIR)/libscotch$(LIB)

EXECPPROG		?= mpirun
EXECPFLAGS		?= $(if $(findstring Open,$(shell $(EXECPPROG) --version)),--oversubscribe)
# EXECPFLAGS		+= valgrind --leak-check=full --show-leak-kinds=all --track-origins=yes
EXECS			?=
# EXECS			+= valgrind --leak-check=full --show-leak-kinds=all --track-origins=yes
EXECP3			?= $(EXECPPROG) -n 3 $(EXECPFLAGS)
EXECP4			?= $(EXECPPROG) -n 4 $(EXECPFLAGS)

PROGDIFF		?= diff -q

##
##  General inference rules.
##

include ../Makefile.inc

%$(OBJ)	:	%.c
				$(CC) $(CFLAGS) $(CLIBFLAGS) -I$(SCOTCHINCDIR) -c $(<) -o $(@)

%$(EXE)	:	%.c
				$(CC) $(CFLAGS) -I$(SCOTCHINCDIR) -L$(SCOTCHLIBDIR) $(<) -o $(@) $(SCOTCHLIBS) $(LDFLAGS)

%$(EXE)	:	%.f90
				$(FC) $(FFLAGS) -I$(SCOTCHINCDIR) -L$(SCOTCHLIBDIR) $(<) -o $(@) $(SCOTCHLIBS) $(LDFLAGS)

##
##  Project rules.
##

.PHONY				:	check	ptcheck	clean	realclean

check				:	realclean
					$(MAKE) CC="$(CCS)" CCD="$(CCS)" SCOTCHLIBS="$(LIBSCOTCH)" $(CHECKSCOTCH)

check_full			:	realclean
					$(MAKE) CC="$(CCS) -DSCOTCH_DEBUG_FULL" CCD="$(CCS)" SCOTCHLIBS="$(LIBSCOTCH)" check_prog_full

ptcheck				:	realclean
					$(MAKE) CFLAGS="$(CFLAGS) -DSCOTCH_PTSCOTCH" CC="$(CCP)" SCOTCHLIBS="$(LIBPTSCOTCH)" $(CHECKPTSCOTCH)

ptcheck_full			:	realclean
					$(MAKE) CFLAGS="$(CFLAGS) -DSCOTCH_PTSCOTCH" CC="$(CCP)" SCOTCHLIBS="$(LIBPTSCOTCH)" check_prog_dfull

escheck				:	realclean
					$(MAKE) CFLAGS="$(CFLAGS)" CC="$(CCP)" SCOTCHLIBS="$(LIBESMUMPS)" $(CHECKESMUMPS)

clean				:
					-$(RM) *~ *$(OBJ)

realclean			:	clean
					-$(RM) 				\
					test_common_file_compress	\
					test_common_random		\
					test_common_thread		\
					test_fibo			\
					test_libesmumps			\
					test_libmetis			\
					test_libmetis_dual		\
					test_libmetis_dual_f		\
					test_scotch_arch		\
					test_scotch_arch_deco		\
					test_scotch_graph_coarsen	\
					test_scotch_graph_color		\
					test_scotch_graph_diam		\
					test_scotch_graph_dump2		\
					test_scotch_graph_dump2.c	\
					test_scotch_graph_induce	\
					test_scotch_graph_map		\
					test_scotch_graph_map_copy	\
					test_scotch_graph_order		\
					test_scotch_graph_part_ovl	\
					test_scotch_dgraph_band		\
					test_scotch_dgraph_check	\
					test_scotch_dgraph_coarsen	\
					test_scotch_dgraph_grow		\
					test_scotch_dgraph_induce	\
					test_scotch_dgraph_redist	\
					test_scotch_mesh_graph		\
					test_strat_par			\
					test_strat_seq

##
##  Test cases dependencies.
##

CHECKSCOTCH = 		check_common_file_compress		\
			check_common_random			\
			check_common_thread			\
			check_fibo				\
			check_strat_seq				\
			check_scotch_arch			\
			check_scotch_arch_deco			\
			check_scotch_graph_coarsen		\
			check_scotch_graph_color		\
			check_scotch_graph_diam			\
			check_scotch_graph_dump			\
			check_scotch_graph_induce		\
			check_scotch_graph_map			\
			check_scotch_graph_map_copy		\
			check_scotch_graph_order		\
			check_scotch_graph_part_ovl		\
			check_scotch_mesh_graph			\
			check_libmetis				\
			check_libmetis_dual			\
			check_libmetis_dual_f			\
			check_prog_amk				\
			check_prog_amk_grf			\
			check_prog_acpl				\
			check_prog_gbase			\
			check_prog_gmap				\
			check_prog_gmk				\
			check_prog_gmk_msh			\
			check_prog_gord				\
			check_prog_gord_block			\
			check_prog_gotst			\
			check_prog_gout				\
			check_prog_gpart			\
			check_prog_gpart_clustering		\
			check_prog_gpart_overlap		\
			check_prog_gpart_remap			\
			check_prog_gscat			\
			check_prog_gtst				\
			check_prog_mmk				\
			check_prog_mord

CHECKPTSCOTCH = 	check_strat_par				\
			check_scotch_dgraph_check		\
			check_scotch_dgraph_band		\
			check_scotch_dgraph_coarsen		\
			check_scotch_dgraph_grow		\
			check_scotch_dgraph_induce      	\
			check_scotch_dgraph_redist		\
			check_prog_dgord			\
			check_prog_dgpart			\
			check_prog_dgscat-dggath		\
			check_prog_dgtst

CHECKESMUMPS = 		check_libesmumps

##
##  Sequential library tests.
##

check_common_file_compress	:	test_common_file_compress
					-cp "data/bump_b1.grf" "$(TMPDIR)/bump_b1.grf"
					$(EXECS) ./test_common_file_compress "data/bump_b1.grf" "$(TMPDIR)/bump_b1.grf.gz"
					$(EXECS) ./test_common_file_compress "$(TMPDIR)/bump_b1.grf.gz" "$(TMPDIR)/bump_b1.grf"
					$(PROGDIFF) "data/bump_b1.grf" "$(TMPDIR)/bump_b1.grf"
					-cp "data/bump_b1.grf" "$(TMPDIR)/bump_b1.grf"
					$(EXECS) ./test_common_file_compress "data/bump_b1.grf" "$(TMPDIR)/bump_b1.grf.bz2"
					$(EXECS) ./test_common_file_compress "$(TMPDIR)/bump_b1.grf.bz2" "$(TMPDIR)/bump_b1.grf"
					$(PROGDIFF) "data/bump_b1.grf" "$(TMPDIR)/bump_b1.grf"
					-cp "data/bump_b1.grf" "$(TMPDIR)/bump_b1.grf"
					$(EXECS) ./test_common_file_compress "data/bump_b1.grf" "$(TMPDIR)/bump_b1.grf.lzma"
					$(EXECS) ./test_common_file_compress "$(TMPDIR)/bump_b1.grf.lzma" "$(TMPDIR)/bump_b1.grf"
					$(PROGDIFF) "data/bump_b1.grf" "$(TMPDIR)/bump_b1.grf"

test_common_file_compress	:	test_common_file_compress.c	\
					$(SCOTCHLIBDIR)/libscotch$(LIB)

##

check_common_random		:	test_common_random
					$(EXECS) ./test_common_random "$(TMPDIR)/rand.dat" 0
					$(EXECS) ./test_common_random "$(TMPDIR)/rand.dat" 1

test_common_random		:	test_common_random.c		\
					$(SCOTCHLIBDIR)/libscotch$(LIB)

##

check_common_thread		:	test_common_thread
					$(EXECS) ./test_common_thread

test_common_thread		:	test_common_thread.c		\
					$(SCOTCHLIBDIR)/libscotch$(LIB)

##

check_fibo			:	test_fibo
					$(EXECS) ./test_fibo

test_fibo			:	test_fibo.c			\
					$(SCOTCHLIBDIR)/libscotch$(LIB)

##

check_libesmumps		:	test_libesmumps
					$(EXECS) ./test_libesmumps data/bump.grf
					$(EXECS) ./test_libesmumps data/bump_imbal_32.grf

test_libesmumps			:	test_libesmumps.c		\
					$(SCOTCHLIBDIR)/libscotch$(LIB)	\
					$(SCOTCHLIBDIR)/libesmumps$(LIB)

##

check_libmetis			:	test_libmetis
					$(EXECS) ./test_libmetis data/bump.grf
					$(EXECS) ./test_libmetis data/bump_b1.grf
					$(EXECS) ./test_libmetis data/bump_imbal_32.grf

test_libmetis			:	test_libmetis.c			\
					$(SCOTCHLIBDIR)/libscotch$(LIB)	\
					$(SCOTCHLIBDIR)/libscotchmetis$(LIB)

##

check_libmetis_dual		:	test_libmetis_dual
					$(EXECS) ./test_libmetis_dual
					$(EXECS) ./test_libmetis_dual 1

test_libmetis_dual		:	test_libmetis_dual.c		\
					$(SCOTCHLIBDIR)/libscotch$(LIB)	\
					$(SCOTCHLIBDIR)/libscotchmetis$(LIB)

##

test_libmetis_dual_f		:	test_libmetis_dual_f.f90	\
					$(SCOTCHLIBDIR)/libscotch$(LIB)	\
					$(SCOTCHLIBDIR)/libscotchmetis$(LIB)

check_libmetis_dual_f		:	test_libmetis_dual_f
					$(EXECS) ./test_libmetis_dual_f

##

check_scotch_arch		:	test_scotch_arch
					$(EXECS) ./test_scotch_arch "$(TMPDIR)/arch.tgt"

test_scotch_arch		:	test_scotch_arch.c		\
					$(SCOTCHLIBDIR)/libscotch$(LIB)

##

check_scotch_arch_deco		:	test_scotch_arch_deco
					$(EXECS) ./test_scotch_arch_deco data/m4x4.grf "$(TMPDIR)/arch2.tgt"
#					$(EXECS) ./test_scotch_arch_deco data/m4x4_b100000.grf "$(TMPDIR)/arch2.tgt"

test_scotch_arch_deco		:	test_scotch_arch_deco.c		\
					$(SCOTCHLIBDIR)/libscotch$(LIB)

##

check_scotch_graph_coarsen	:	test_scotch_graph_coarsen
					$(EXECS) ./test_scotch_graph_coarsen data/bump.grf
					$(EXECS) ./test_scotch_graph_coarsen data/bump_b100000.grf

test_scotch_graph_coarsen	:	test_scotch_graph_coarsen.c	\
					$(SCOTCHLIBDIR)/libscotch$(LIB)

##

check_scotch_graph_color	:	test_scotch_graph_color
					$(EXECS) ./test_scotch_graph_color data/bump.grf
					$(EXECS) ./test_scotch_graph_color data/bump_b100000.grf

test_scotch_graph_color		:	test_scotch_graph_color.c	\
					$(SCOTCHLIBDIR)/libscotch$(LIB)

##

check_scotch_graph_diam		:	test_scotch_graph_diam
					$(EXECS) ./test_scotch_graph_diam data/bump_b100000.grf
					$(EXECS) ./test_scotch_graph_diam data/m16x16_b100000.grf
					$(EXECS) ./test_scotch_graph_diam data/p2-p2.grf

test_scotch_graph_diam		:	test_scotch_graph_diam.c	\
					$(SCOTCHLIBDIR)/libscotch$(LIB)

##

check_scotch_graph_dump		:	test_scotch_graph_dump2
					$(EXECS) ./test_scotch_graph_dump2 $(TMPDIR)/m16x16_b1.grf
					$(PROGDIFF) "data/bump_b1.grf" "$(TMPDIR)/bump_b1.grf"

test_scotch_graph_dump2		:	test_scotch_graph_dump2.c	\
					$(SCOTCHLIBDIR)/libscotch$(LIB)

test_scotch_graph_dump2.c	:	test_scotch_graph_dump.c
					$(EXECS) $(SCOTCHBINDIR)/gdump -ptest data/m16x16_b1.grf $(TMPDIR)/m16x16_b1.c
					$(CAT) test_scotch_graph_dump.c $(TMPDIR)/m16x16_b1.c > $(@)


##

check_scotch_graph_induce	:	test_scotch_graph_induce
					$(EXECS) ./test_scotch_graph_induce data/bump.grf
					$(EXECS) ./test_scotch_graph_induce data/bump_b100000.grf

test_scotch_graph_induce	:	test_scotch_graph_induce.c	\
					$(SCOTCHLIBDIR)/libscotch$(LIB)

##

check_scotch_graph_map		:	test_scotch_graph_map
					$(EXECS) ./test_scotch_graph_map data/m4x4.grf
					$(EXECS) ./test_scotch_graph_map data/m4x4_b100000.grf
					$(EXECS) ./test_scotch_graph_map data/m16x16.grf
					$(EXECS) ./test_scotch_graph_map data/m16x16_b100000.grf

test_scotch_graph_map		:	test_scotch_graph_map.c		\
					$(SCOTCHLIBDIR)/libscotch$(LIB)

##

check_scotch_graph_map_copy	:	test_scotch_graph_map_copy
					$(EXECS) ./test_scotch_graph_map_copy data/bump.grf
					$(EXECS) ./test_scotch_graph_map_copy data/bump_b100000.grf

test_scotch_graph_map_copy	:	test_scotch_graph_map_copy.c	\
					$(SCOTCHLIBDIR)/libscotch$(LIB)

##

check_scotch_graph_order	:	test_scotch_graph_order
					$(EXECS) ./test_scotch_graph_order data/bump.grf
					$(EXECS) ./test_scotch_graph_order data/bump_b100000.grf

test_scotch_graph_order		:	test_scotch_graph_order.c	\
					$(SCOTCHLIBDIR)/libscotch$(LIB)

##

check_scotch_graph_part_ovl	:	test_scotch_graph_part_ovl
					$(EXECS) ./test_scotch_graph_part_ovl 4 data/m16x16.grf /dev/null
					$(EXECS) ./test_scotch_graph_part_ovl 4 data/m16x16_b100000.grf /dev/null

test_scotch_graph_part_ovl	:	test_scotch_graph_part_ovl.c	\
					$(SCOTCHLIBDIR)/libscotch$(LIB)

##

check_scotch_mesh_graph		:	test_scotch_mesh_graph

=== src/libscotch/Makefile ===
## Copyright 2004,2007-2020 IPB, Universite de Bordeaux, INRIA & CNRS
##
## This file is part of the Scotch software package for static mapping,
## graph partitioning and sparse matrix ordering.
##
## This software is governed by the CeCILL-C license under French law
## and abiding by the rules of distribution of free software. You can
## use, modify and/or redistribute the software under the terms of the
## CeCILL-C license as circulated by CEA, CNRS and INRIA at the following
## URL: "http://www.cecill.info".
##
## As a counterpart to the access to the source code and rights to copy,
## modify and redistribute granted by the license, users are provided
## only with a limited warranty and the software's author, the holder of
## the economic rights, and the successive licensors have only limited
## liability.
##
## In this respect, the user's attention is drawn to the risks associated
## with loading, using, modifying and/or developing or reproducing the
## software by the user in light of its specific status of free software,
## that may mean that it is complicated to manipulate, and that also
## therefore means that it is reserved for developers and experienced
## professionals having in-depth computer knowledge. Users are therefore
## encouraged to load and test the software's suitability as regards
## their requirements in conditions enabling the security of their
## systems and/or data to be ensured and, more generally, to use and
## operate it in the same conditions as regards security.
##
## The fact that you are presently reading this means that you have had
## knowledge of the CeCILL-C license and that you accept its terms.
##

includedir	= ../../include
libdir		= ../../lib

include ../Makefile.inc

CCDFLAGS	?= $(CFLAGS)

ifneq ($(strip $(SCOTCH_NAME_SUFFIX)),)
CFLAGS		+= -DSCOTCH_NAME_SUFFIX=$(SCOTCH_NAME_SUFFIX)
CCDFLAGS	+= -DSCOTCH_NAME_SUFFIX=$(SCOTCH_NAME_SUFFIX)
endif

##
##  General inference rules.
##

%$(OBJ)	:	%.c
				$(CC) $(CFLAGS) $(CLIBFLAGS) -c $(<) -o $(@) -DSCOTCH_VERSION_NUM=$(VERSION) -DSCOTCH_RELEASE_NUM=$(RELEASE) -DSCOTCH_PATCHLEVEL_NUM=$(PATCHLEVEL)

%$(EXE)	:	%.c
		 		$(CC) $(CFLAGS) -DSCOTCH_VERSION_NUM=$(VERSION) -DSCOTCH_RELEASE_NUM=$(RELEASE) -DSCOTCH_PATCHLEVEL_NUM=$(PATCHLEVEL) $(<) -o $(@) $(LDFLAGS)

##
##  Project rules.
##

.PHONY				:	ptscotch	scotch	ptinstall	install	clean	realclean

scotch				:
					$(MAKE) 					\
					CC="$(CCS)"					\
					CCD="$(CCS)"					\
					scotch.h					\
					scotchf.h					\
					libscotch$(LIB)					\
					libscotcherr$(LIB)				\
					libscotcherrexit$(LIB)

ptscotch			:	scotch
					$(MAKE) 					\
					CC="$(CCP)"					\
					CFLAGS="$(CFLAGS) -DSCOTCH_PTSCOTCH"		\
					CCDFLAGS="$(CCDFLAGS) -DSCOTCH_PTSCOTCH"	\
					ptscotch.h					\
					ptscotchf.h					\
					libptscotch$(LIB)				\
					libptscotcherr$(LIB)				\
					libptscotcherrexit$(LIB)

install				:	$(includedir)/scotch.h			\
					$(includedir)/scotchf.h			\
					$(libdir)/libscotch$(LIB)

ptinstall			:	install					\
					$(includedir)/ptscotch.h		\
					$(includedir)/ptscotchf.h		\
					$(libdir)/libptscotch$(LIB)

clean				:
					-$(RM) *~ *$(OBJ) lib*$(LIB) parser_yy.c parser_ly.h parser_ll.c *scotch.h *scotchf.h y.output *dummysizes$(EXE)

realclean			:	clean


##
##  Installation dependencies
##

$(includedir)/scotch.h		:	scotch.h
					-$(CP) scotch.h $(includedir)

$(includedir)/scotchf.h		:	scotchf.h
					-$(CP) scotchf.h $(includedir)

$(includedir)/ptscotch.h	:	ptscotch.h
					-$(CP) ptscotch.h $(includedir)

$(includedir)/ptscotchf.h	:	ptscotchf.h
					-$(CP) ptscotchf.h $(includedir)

$(libdir)/libscotch$(LIB)	:	libscotch$(LIB)
					-$(CP) libscotch$(LIB) libscotcherr*$(LIB) $(libdir)

$(libdir)/libptscotch$(LIB)	:	libptscotch$(LIB)
					-$(CP) libptscotch$(LIB) libptscotcherr*$(LIB) $(libdir)

##
##  Library dependencies.
##

LIBPTSCOTCHDEPS =	bdgraph$(OBJ)				\
			bdgraph_bipart_bd$(OBJ)			\
			bdgraph_bipart_df$(OBJ)			\
			bdgraph_bipart_ex$(OBJ)			\
			bdgraph_bipart_ml$(OBJ)			\
			bdgraph_bipart_sq$(OBJ)			\
			bdgraph_bipart_st$(OBJ)			\
			bdgraph_bipart_zr$(OBJ)			\
			bdgraph_check$(OBJ)			\
			bdgraph_gather_all$(OBJ)		\
			bdgraph_store$(OBJ)			\
			comm$(OBJ)				\
			dgraph$(OBJ)				\
			dgraph_allreduce$(OBJ)			\
			dgraph_band$(OBJ)			\
			dgraph_build$(OBJ)			\
			dgraph_build_grid3d$(OBJ)		\
			dgraph_build_hcub$(OBJ)			\
			dgraph_check$(OBJ)			\
			dgraph_coarsen$(OBJ)			\
			dgraph_fold$(OBJ)			\
			dgraph_fold_comm$(OBJ)			\
			dgraph_fold_dup$(OBJ)			\
			dgraph_gather$(OBJ)			\
			dgraph_gather_all$(OBJ)			\
			dgraph_ghst$(OBJ)			\
			dgraph_halo$(OBJ)			\
			dgraph_induce$(OBJ)			\
			dgraph_io_load$(OBJ)			\
			dgraph_io_save$(OBJ)			\
			dgraph_match$(OBJ)			\
			dgraph_match_sync_coll$(OBJ)		\
			dgraph_match_sync_ptop$(OBJ)		\
			dgraph_match_check$(OBJ)		\
			dgraph_redist$(OBJ)			\
			dgraph_scatter$(OBJ)			\
			dgraph_view$(OBJ)			\
			dmapping$(OBJ)				\
			dmapping_io$(OBJ)			\
			dorder$(OBJ)				\
			dorder_gather$(OBJ)			\
			dorder_io$(OBJ)				\
			dorder_io_block$(OBJ)			\
			dorder_io_tree$(OBJ)			\
			dorder_perm$(OBJ)			\
			dorder_tree_dist$(OBJ)			\
			hdgraph$(OBJ)				\
			hdgraph_check$(OBJ)			\
			hdgraph_fold$(OBJ)			\
			hdgraph_gather$(OBJ)			\
			hdgraph_induce$(OBJ)			\
			hdgraph_order_nd$(OBJ)			\
			hdgraph_order_si$(OBJ)			\
			hdgraph_order_sq$(OBJ)			\
			hdgraph_order_st$(OBJ)			\
			kdgraph$(OBJ)				\
			kdgraph_gather$(OBJ)			\
			kdgraph_map_rb$(OBJ)			\
			kdgraph_map_rb_map$(OBJ)		\
			kdgraph_map_rb_part$(OBJ)		\
			kdgraph_map_st$(OBJ)			\
			library_dgraph$(OBJ)			\
			library_dgraph_f$(OBJ)			\
			library_dgraph_band$(OBJ)		\
			library_dgraph_band_f$(OBJ)		\
			library_dgraph_build$(OBJ)		\
			library_dgraph_build_f$(OBJ)		\
			library_dgraph_build_grid3d$(OBJ)	\
			library_dgraph_build_grid3d_f$(OBJ)	\
			library_dgraph_check$(OBJ)		\
			library_dgraph_check_f$(OBJ)		\
			library_dgraph_coarsen$(OBJ)		\
			library_dgraph_coarsen_f$(OBJ)		\
			library_dgraph_gather$(OBJ)		\
			library_dgraph_gather_f$(OBJ)		\
			library_dgraph_grow$(OBJ)		\
			library_dgraph_halo$(OBJ)		\
			library_dgraph_halo_f$(OBJ)		\
			library_dgraph_induce$(OBJ)		\
			library_dgraph_induce_f$(OBJ)		\
			library_dgraph_io_load$(OBJ)		\
			library_dgraph_io_load_f$(OBJ)		\
			library_dgraph_io_save$(OBJ)		\
			library_dgraph_io_save_f$(OBJ)		\
			library_dgraph_map$(OBJ)		\
			library_dgraph_map_f$(OBJ)		\
			library_dgraph_map_view$(OBJ)		\
			library_dgraph_map_view_f$(OBJ)		\
			library_dgraph_order$(OBJ)		\
			library_dgraph_order_f$(OBJ)		\
			library_dgraph_order_gather$(OBJ)	\
			library_dgraph_order_gather_f$(OBJ)	\
			library_dgraph_order_io$(OBJ)		\
			library_dgraph_order_io_f$(OBJ)		\
			library_dgraph_order_io_block$(OBJ)	\
			library_dgraph_order_io_block_f$(OBJ)	\
			library_dgraph_order_perm$(OBJ)		\
			library_dgraph_order_perm_f$(OBJ)	\
			library_dgraph_order_tree_dist$(OBJ)	\
			library_dgraph_order_tree_dist_f$(OBJ)	\
			library_dgraph_redist$(OBJ)		\
			library_dgraph_redist_f$(OBJ)		\
			library_dgraph_scatter$(OBJ)		\
			library_dgraph_scatter_f$(OBJ)		\
			library_dgraph_stat$(OBJ)		\
			library_dgraph_stat_f$(OBJ)		\
			library_dmapping$(OBJ)			\
			library_dorder$(OBJ)			\
			vdgraph$(OBJ)				\
			vdgraph_check$(OBJ)			\
			vdgraph_gather_all$(OBJ)		\
			vdgraph_separate_bd$(OBJ)		\
			vdgraph_separate_df$(OBJ)		\
			vdgraph_separate_ml$(OBJ)		\
			vdgraph_separate_sq$(OBJ)		\
			vdgraph_separate_st$(OBJ)		\
			vdgraph_separate_zr$(OBJ)		\
			vdgraph_store$(OBJ)

LIBSCOTCHDEPS	=	arch$(OBJ)				\
			arch_build$(OBJ)			\
			arch_build2$(OBJ)			\
			arch_cmplt$(OBJ)			\
			arch_cmpltw$(OBJ)			\
			arch_deco$(OBJ)				\
			arch_deco2$(OBJ)			\
			arch_dist$(OBJ)				\
			arch_hcub$(OBJ)				\
			arch_mesh$(OBJ)				\
			arch_sub$(OBJ)				\
			arch_tleaf$(OBJ)			\
			arch_torus$(OBJ)			\
			arch_vcmplt$(OBJ)			\
			arch_vhcub$(OBJ)			\
			bgraph$(OBJ)				\
			bgraph_bipart_bd$(OBJ)			\
			bgraph_bipart_df$(OBJ)			\
			bgraph_bipart_ex$(OBJ)			\
			bgraph_bipart_fm$(OBJ)			\
			bgraph_bipart_gg$(OBJ)			\
			bgraph_bipart_gp$(OBJ)			\
			bgraph_bipart_ml$(OBJ)			\
			bgraph_bipart_st$(OBJ)			\
			bgraph_bipart_zr$(OBJ)			\
			bgraph_check$(OBJ)			\
			bgraph_store$(OBJ)			\
			common$(OBJ)				\
			common_file$(OBJ)			\
			common_file_compress$(OBJ)		\
			common_file_decompress$(OBJ)		\
			common_integer$(OBJ)			\
			common_memory$(OBJ)			\
			common_string$(OBJ)			\
			common_stub$(OBJ)			\
			common_thread$(OBJ)			\
			fibo$(OBJ)				\
			gain$(OBJ)				\
			geom$(OBJ)				\
			graph$(OBJ)				\
			graph_base$(OBJ)			\
			graph_band$(OBJ)			\
			graph_check$(OBJ)			\
			graph_clone$(OBJ)			\
			graph_coarsen$(OBJ)			\
			graph_diam$(OBJ)			\
			graph_dump$(OBJ)			\
			graph_ielo$(OBJ)			\
			graph_induce$(OBJ)			\
			graph_io$(OBJ)				\
			graph_io_chac$(OBJ)			\
			graph_io_habo$(OBJ)			\
			graph_io_mmkt$(OBJ)			\
			graph_io_scot$(OBJ)			\
			graph_list$(OBJ)			\
			graph_match$(OBJ)			\
			hall_order_hd$(OBJ)			\
			hall_order_hf$(OBJ)			\
			hall_order_hx$(OBJ)			\
			hgraph$(OBJ)				\
			hgraph_check$(OBJ)			\
			hgraph_dump$(OBJ)			\
			hgraph_induce$(OBJ)			\
			hgraph_order_bl$(OBJ)			\
			hgraph_order_cc$(OBJ)			\
			hgraph_order_cp$(OBJ)			\
			hgraph_order_gp$(OBJ)			\
			hgraph_order_hd$(OBJ)			\
			hgraph_order_hf$(OBJ)			\
			hgraph_order_hx$(OBJ)			\
			hgraph_order_kp$(OBJ)			\
			hgraph_order_nd$(OBJ)			\
			hgraph_order_si$(OBJ)			\
			hgraph_order_st$(OBJ)			\
			hmesh$(OBJ)				\
			hmesh_check$(OBJ)			\
			hmesh_hgraph$(OBJ)			\
			hmesh_induce$(OBJ)			\
			hmesh_mesh$(OBJ)			\
			hmesh_order_bl$(OBJ)			\
			hmesh_order_cp$(OBJ)			\
			hmesh_order_gr$(OBJ)			\
			hmesh_order_gp$(OBJ)			\
			hmesh_order_hd$(OBJ)			\
			hmesh_order_hf$(OBJ)			\
			hmesh_order_hx$(OBJ)			\
			hmesh_order_nd$(OBJ)			\
			hmesh_order_si$(OBJ)			\
			hmesh_order_st$(OBJ)			\
			kgraph$(OBJ)				\
			kgraph_band$(OBJ)			\
			kgraph_check$(OBJ)			\
			kgraph_map_bd$(OBJ)			\
			kgraph_map_cp$(OBJ)			\
			kgraph_map_df$(OBJ)			\
			kgraph_map_ex$(OBJ)			\
			kgraph_map_fm$(OBJ)			\
			kgraph_map_ml$(OBJ)			\
			kgraph_map_rb$(OBJ)			\
			kgraph_map_rb_map$(OBJ)			\
			kgraph_map_rb_part$(OBJ)		\
			kgraph_map_st$(OBJ)			\
			kgraph_store$(OBJ)			\
			library_arch$(OBJ)			\
			library_arch_f$(OBJ)			\
			library_arch_build$(OBJ)		\
			library_arch_build_f$(OBJ)		\
			library_arch_dom$(OBJ)			\
			library_arch_dom_f$(OBJ)		\
			library_common_f$(OBJ)			\
			library_geom$(OBJ)			\
			library_geom_f$(OBJ)			\
			library_graph$(OBJ)			\
			library_graph_f$(OBJ)			\
			library_graph_base$(OBJ)		\
			library_graph_base_f$(OBJ)		\
			library_graph_check$(OBJ)		\
			library_graph_check_f$(OBJ)		\
			library_graph_coarsen$(OBJ)		\
			library_graph_coarsen_f$(OBJ)		\
			library_graph_color$(OBJ)		\
			library_graph_color_f$(OBJ)		\
			library_graph_diam$(OBJ)		\
			library_graph_diam_f$(OBJ)		\
			library_graph_dump$(OBJ)		\
			library_graph_induce$(OBJ)		\
			library_graph_induce_f$(OBJ)		\
			library_graph_io_chac$(OBJ)		\
			library_graph_io_chac_f$(OBJ)		\
			library_graph_io_habo$(OBJ)		\
			library_graph_io_habo_f$(OBJ)		\
			library_graph_io_mmkt$(OBJ)		\
			library_graph_io_mmkt_f$(OBJ)		\
			library_graph_io_scot$(OBJ)		\
			library_graph_io_scot_f$(OBJ)		\
			library_graph_map$(OBJ)			\
			library_graph_map_f$(OBJ)		\
			library_graph_map_io$(OBJ)		\
			library_graph_map_io_f$(OBJ)		\
			library_graph_map_view$(OBJ)		\
			library_graph_map_view_f$(OBJ)		\
			library_graph_order$(OBJ)		\
			library_graph_order_f$(OBJ)		\
			library_graph_part_ovl$(OBJ)		\
			library_graph_part_ovl_f$(OBJ)		\
			library_mapping$(OBJ)			\
			library_memory$(OBJ)			\
			library_memory_f$(OBJ)			\
			library_mesh$(OBJ)			\
			library_mesh_f$(OBJ)			\
			library_mesh_graph$(OBJ)		\
			library_mesh_graph_f$(OBJ)		\
			library_mesh_io_habo$(OBJ)		\
			library_mesh_io_habo_f$(OBJ)		\
			library_mesh_io_scot$(OBJ)		\
			library_mesh_io_scot_f$(OBJ)		\
			library_mesh_order$(OBJ)		\

=== src/libscotchmetis/Makefile ===
## Copyright 2007-2010,2018,2019,2021 IPB, Universite de Bordeaux, INRIA & CNRS
##
## This file is part of the Scotch software package for static mapping,
## graph partitioning and sparse matrix ordering.
##
## This software is governed by the CeCILL-C license under French law
## and abiding by the rules of distribution of free software. You can
## use, modify and/or redistribute the software under the terms of the
## CeCILL-C license as circulated by CEA, CNRS and INRIA at the following
## URL: "http://www.cecill.info".
##
## As a counterpart to the access to the source code and rights to copy,
## modify and redistribute granted by the license, users are provided
## only with a limited warranty and the software's author, the holder of
## the economic rights, and the successive licensors have only limited
## liability.
##
## In this respect, the user's attention is drawn to the risks associated
## with loading, using, modifying and/or developing or reproducing the
## software by the user in light of its specific status of free software,
## that may mean that it is complicated to manipulate, and that also
## therefore means that it is reserved for developers and experienced
## professionals having in-depth computer knowledge. Users are therefore
## encouraged to load and test the software's suitability as regards
## their requirements in conditions enabling the security of their
## systems and/or data to be ensured and, more generally, to use and
## operate it in the same conditions as regards security.
##
## The fact that you are presently reading this means that you have had
## knowledge of the CeCILL-C license and that you accept its terms.
##

bindir		= ../../bin
includedir	= ../../include
libdir		= ../../lib

##
##  General inference rules.
##

include ../Makefile.inc

%$(OBJ)	:	%.c
				$(CC) $(CFLAGS) $(CLIBFLAGS) -I$(includedir) -I../libscotch -c $(<) -o $(@)

%$(EXE)	:	%.c
		 		$(CC) $(CFLAGS) -I$(includedir) -I../libscotch $(<) -o $(@) -L$(libdir) $(LDFLAGS)

##
##  Project rules.
##

.PHONY				:	ptscotch	scotch	ptinstall	install	clean	realclean

scotch				:
					$(MAKE)						\
					CC="$(CCS)"					\
					metis.h						\
					metisf.h					\
					libscotchmetis$(LIB)

ptscotch			:
					$(MAKE)						\
					CC="$(CCP)"					\
					CFLAGS="$(CFLAGS) -DSCOTCH_PTSCOTCH"		\
					parmetis.h					\
					libptscotchparmetis$(LIB)

install				:	scotch
					-$(CP) metis.h metisf.h $(includedir)
					-$(CP) libscotchmetis$(LIB) $(libdir)

ptinstall			:	ptscotch
					-$(CP) parmetis.h $(includedir)
					-$(CP) libptscotchparmetis$(LIB) $(libdir)

clean				:
					-$(RM) *~ *$(OBJ) lib*$(LIB) metis.h metisf.h parmetis.h

realclean			:	clean

##
##  Todo list.
##

metis.h				:	../libscotch/dummysizes$(EXE)		\
					library_metis.h
					../libscotch/dummysizes$(EXE) library_metis.h metis.h

metisf.h			:	../libscotch/dummysizes$(EXE)		\
					library_metis_f.h
					../libscotch/dummysizes$(EXE) library_metis_f.h metisf.h

metis_graph_dual$(OBJ)		:	metis_graph_dual.c			\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/scotch.h			\
					metis.h					\
					metis_graph_dual.h

metis_graph_dual_f$(OBJ)	:	metis_graph_dual_f.c			\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/scotch.h			\
					metis.h

metis_graph_order$(OBJ)		:	metis_graph_order.c			\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/scotch.h			\
					metis.h

metis_graph_order_f$(OBJ)	:	metis_graph_order_f.c			\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/scotch.h			\
					metis.h

metis_graph_part$(OBJ)		:	metis_graph_part.c			\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/scotch.h			\
					metis.h					\
					metis_graph_part.h

metis_graph_part_f$(OBJ)	:	metis_graph_part_f.c			\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/scotch.h			\
					metis.h

metis_graph_part_dual$(OBJ)	:	metis_graph_part_dual.c			\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/scotch.h			\
					metis.h					\
					metis_graph_dual.h			\
					metis_graph_part.h

metis_graph_part_dual_f$(OBJ)	:	metis_graph_part_dual_f.c		\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/scotch.h			\
					metis.h

metis_options$(OBJ)		:	metis_options.c				\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/scotch.h			\
					metis.h

metis_options_f$(OBJ)		:	metis_options_f.c			\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/scotch.h			\
					metis.h

parmetis.h			:	../libscotch/dummysizes$(EXE)		\
					library_parmetis.h
					../libscotch/dummysizes$(EXE) library_parmetis.h parmetis.h

parmetis_dgraph_order$(OBJ)	:	parmetis_dgraph_order.c			\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/ptscotch.h		\
					parmetis.h

parmetis_dgraph_order_f$(OBJ)	:	parmetis_dgraph_order_f.c		\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/ptscotch.h		\
					parmetis.h

parmetis_dgraph_part$(OBJ)	:	parmetis_dgraph_part.c			\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/ptscotch.h		\
					parmetis.h

parmetis_dgraph_part_f$(OBJ)	:	parmetis_dgraph_part_f.c		\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/ptscotch.h		\
					parmetis.h

libptscotchparmetis$(LIB)	:	parmetis_dgraph_order$(OBJ)		\
					parmetis_dgraph_order_f$(OBJ)		\
					parmetis_dgraph_part$(OBJ)		\
					parmetis_dgraph_part_f$(OBJ)
					$(AR) $(ARFLAGS) $(@) $(^)
					-$(RANLIB) $(@)

libscotchmetis$(LIB)		:	metis_graph_dual$(OBJ)			\
					metis_graph_dual_f$(OBJ)		\
					metis_graph_order$(OBJ)			\
					metis_graph_order_f$(OBJ)		\
					metis_graph_part$(OBJ)			\
					metis_graph_part_f$(OBJ)		\
					metis_graph_part_dual$(OBJ)		\
					metis_graph_part_dual_f$(OBJ)		\
					metis_options$(OBJ)			\
					metis_options_f$(OBJ)
					$(AR) $(ARFLAGS) $(@) $(^)
					-$(RANLIB) $(@)

=== src/scotch/Makefile ===
## Copyright 2004,2007-2012,2019 IPB, Universite de Bordeaux, INRIA & CNRS
##
## This file is part of the Scotch software package for static mapping,
## graph partitioning and sparse matrix ordering.
##
## This software is governed by the CeCILL-C license under French law
## and abiding by the rules of distribution of free software. You can
## use, modify and/or redistribute the software under the terms of the
## CeCILL-C license as circulated by CEA, CNRS and INRIA at the following
## URL: "http://www.cecill.info".
##
## As a counterpart to the access to the source code and rights to copy,
## modify and redistribute granted by the license, users are provided
## only with a limited warranty and the software's author, the holder of
## the economic rights, and the successive licensors have only limited
## liability.
##
## In this respect, the user's attention is drawn to the risks associated
## with loading, using, modifying and/or developing or reproducing the
## software by the user in light of its specific status of free software,
## that may mean that it is complicated to manipulate, and that also
## therefore means that it is reserved for developers and experienced
## professionals having in-depth computer knowledge. Users are therefore
## encouraged to load and test the software's suitability as regards
## their requirements in conditions enabling the security of their
## systems and/or data to be ensured and, more generally, to use and
## operate it in the same conditions as regards security.
##
## The fact that you are presently reading this means that you have had
## knowledge of the CeCILL-C license and that you accept its terms.
##

bindir		= ../../bin
includedir	= ../../include
libdir		= ../../lib

##
##  General inference rules.
##

include ../Makefile.inc

%$(EXE)	:	%$(OBJ)
		 		$(CC) $(CFLAGS) -I$(includedir) -I../libscotch $(<) -o $(@) -L$(libdir) -l$(SCOTCHLIB) -lscotch -l$(SCOTCHLIB)errexit $(LDFLAGS)

%$(OBJ)	:	%.c
				$(CC) $(CFLAGS) -I$(includedir) -I../libscotch -c $(<) -o $(@)

%$(EXE)	:	%.c
		 		$(CC) $(CFLAGS) -I$(includedir) -I../libscotch $(<) -o $(@) -L$(libdir) -l$(SCOTCHLIB) -lscotch -l$(SCOTCHLIB)errexit $(LDFLAGS)

##
##  Project rules.
##

.PHONY				:	ptscotch	scotch	ptinstall	install	clean	realclean

scotch				:
					$(MAKE) CC="$(CCS)" SCOTCHLIB=scotch	\
					acpl$(EXE)				\
					amk_ccc$(EXE)				\
					amk_fft2$(EXE)				\
					amk_grf$(EXE)				\
					amk_hy$(EXE)				\
					amk_m2$(EXE)				\
					amk_p2$(EXE)				\
					atst$(EXE)				\
					gbase$(EXE)				\
					gcv$(EXE)				\
					gdump$(EXE)				\
					gmap$(EXE)				\
					gmk_hy$(EXE)				\
					gmk_m2$(EXE)				\
					gmk_m3$(EXE)				\
					gmk_msh$(EXE)				\
					gmk_ub2$(EXE)				\
					gmtst$(EXE)				\
					gord$(EXE)				\
					gotst$(EXE)				\
					gout$(EXE)				\
					gpart$(EXE)				\
					gscat$(EXE)				\
					gtst$(EXE)				\
					mcv$(EXE)				\
					mmk_m2$(EXE)				\
					mmk_m3$(EXE)				\
					mord$(EXE)				\
					mtst$(EXE)

ptscotch			:
					$(MAKE) CC="$(CCP)" SCOTCHLIB=ptscotch	\
					dggath$(EXE)				\
					dgmap$(EXE)				\
					dgord$(EXE)				\
					dgpart$(EXE)				\
					dgscat$(EXE)				\
					dgtst$(EXE)

install				:	scotch
					-$(CP) acpl$(EXE) amk_ccc$(EXE) amk_fft2$(EXE) amk_grf$(EXE) amk_hy$(EXE) amk_m2$(EXE) amk_p2$(EXE) atst$(EXE) gbase$(EXE) gcv$(EXE) gdump$(EXE) gmap$(EXE) gmk_hy$(EXE) gmk_m2$(EXE) gmk_m3$(EXE) gmk_msh$(EXE) gmk_ub2$(EXE) gmtst$(EXE) gord$(EXE) gotst$(EXE) gout$(EXE) gpart$(EXE) *gtst$(EXE) gscat$(EXE) mcv$(EXE) mmk_m2$(EXE) mmk_m3$(EXE) mord$(EXE) mtst$(EXE) $(bindir)

ptinstall			:	ptscotch
					-$(CP) dggath$(EXE) dgmap$(EXE) dgord$(EXE) dgpart$(EXE) dgscat$(EXE) dgtst$(EXE) $(bindir)

clean				:
					-$(RM) *~ *$(OBJ) acpl$(EXE) amk_ccc$(EXE) amk_fft2$(EXE) amk_grf$(EXE) amk_hy$(EXE) amk_m2$(EXE) amk_p2$(EXE) atst$(EXE) gbase$(EXE) gcv$(EXE) gdump$(EXE) *ggath$(EXE) *gmap$(EXE) gmk_hy$(EXE) gmk_m2$(EXE) gmk_m3$(EXE) gmk_msh$(EXE) gmk_ub2$(EXE) gmtst$(EXE) *gord$(EXE) gotst$(EXE) gout$(EXE) *gpart$(EXE) *gscat$(EXE) *gtst$(EXE) mcv$(EXE) mmk_m2$(EXE) mmk_m3$(EXE) mord$(EXE) mtst$(EXE)

realclean			:	clean

##
##  Todo list.
##

acpl$(EXE)			:	acpl.c					\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/scotch.h			\
					$(libdir)/libscotch$(LIB)		\
					$(libdir)/libscotcherrexit$(LIB)	\
					acpl.h

amk_ccc$(EXE)			:	amk_ccc.c				\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/scotch.h			\
					$(libdir)/libscotch$(LIB)		\
					$(libdir)/libscotcherrexit$(LIB)	\
					amk_ccc.h

amk_fft2$(EXE)			:	amk_fft2.c				\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/scotch.h			\
					$(libdir)/libscotch$(LIB)		\
					$(libdir)/libscotcherrexit$(LIB)	\
					amk_fft2.h

amk_grf$(EXE)			:	amk_grf.c				\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/scotch.h			\
					$(libdir)/libscotch$(LIB)		\
					$(libdir)/libscotcherrexit$(LIB)	\
					amk_grf.h

amk_hy$(EXE)			:	amk_hy.c				\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/scotch.h			\
					$(libdir)/libscotch$(LIB)		\
					$(libdir)/libscotcherrexit$(LIB)	\
					amk_hy.h

amk_m2$(EXE)			:	amk_m2.c				\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/scotch.h			\
					$(libdir)/libscotch$(LIB)		\
					$(libdir)/libscotcherrexit$(LIB)	\
					amk_m2.h

amk_p2$(EXE)			:	amk_p2.c				\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/scotch.h			\
					$(libdir)/libscotch$(LIB)		\
					$(libdir)/libscotcherrexit$(LIB)	\
					amk_p2.h

atst$(EXE)			:	atst.c					\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/scotch.h			\
					$(libdir)/libscotch$(LIB)		\
					$(libdir)/libscotcherrexit$(LIB)	\
					atst.h

dggath$(EXE)			:	dggath.c				\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/ptscotch.h		\
					$(libdir)/libscotch$(LIB)		\
					$(libdir)/libptscotch$(LIB)		\
					$(libdir)/libptscotcherrexit$(LIB)	\
					dggath.h

dgmap$(EXE)			:	dgmap.c					\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/ptscotch.h		\
					$(libdir)/libscotch$(LIB)		\
					$(libdir)/libptscotch$(LIB)		\
					$(libdir)/libptscotcherrexit$(LIB)	\
					dgmap.h

dgord$(EXE)			:	dgord.c					\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/ptscotch.h		\
					$(libdir)/libscotch$(LIB)		\
					$(libdir)/libptscotch$(LIB)		\
					$(libdir)/libptscotcherrexit$(LIB)	\
					dgord.h

dgpart$(EXE)			:	dgmap.c					\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/ptscotch.h		\
					$(libdir)/libscotch$(LIB)		\
					$(libdir)/libptscotch$(LIB)		\
					$(libdir)/libptscotcherrexit$(LIB)	\
					dgmap.h
			 		$(CC) $(CFLAGS) -I$(includedir) -I../libscotch $(<) -DSCOTCH_COMPILE_PART -o $(@) -L$(libdir) -lptscotch -lscotch -lptscotcherrexit $(LDFLAGS)

dgscat$(EXE)			:	dgscat.c				\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/ptscotch.h		\
					$(libdir)/libscotch$(LIB)		\
					$(libdir)/libptscotch$(LIB)		\
					$(libdir)/libptscotcherrexit$(LIB)	\
					dgscat.h

dgtst$(EXE)			:	dgtst.c					\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/ptscotch.h		\
					$(libdir)/libscotch$(LIB)		\
					$(libdir)/libptscotch$(LIB)		\
					$(libdir)/libptscotcherrexit$(LIB)	\
					dgtst.h

gbase$(EXE)			:	gbase.c					\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/scotch.h			\
					$(libdir)/libscotch$(LIB)		\
					$(libdir)/libscotcherrexit$(LIB)	\
					gbase.h

gcv$(EXE)			:	gcv.c					\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/scotch.h			\
					$(libdir)/libscotch$(LIB)		\
					$(libdir)/libscotcherrexit$(LIB)	\
					gcv.h

gdump$(EXE)			:	gdump.c					\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/scotch.h			\
					$(libdir)/libscotch$(LIB)		\
					$(libdir)/libscotcherrexit$(LIB)	\
					gdump.h

gmap$(EXE)			:	gmap.c					\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/scotch.h			\
					$(libdir)/libscotch$(LIB)		\
					$(libdir)/libscotcherrexit$(LIB)	\
					gmap.h

gmk_hy$(EXE)			:	gmk_hy.c				\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/scotch.h			\
					$(libdir)/libscotch$(LIB)		\
					$(libdir)/libscotcherrexit$(LIB)	\
					gmk_hy.h

gmk_m2$(EXE)			:	gmk_m2.c				\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/scotch.h			\
					$(libdir)/libscotch$(LIB)		\
					$(libdir)/libscotcherrexit$(LIB)	\
					gmk_m2.h

gmk_m3$(EXE)			:	gmk_m3.c				\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/scotch.h			\
					$(libdir)/libscotch$(LIB)		\
					$(libdir)/libscotcherrexit$(LIB)	\
					gmk_m3.h

gmk_msh$(EXE)			:	gmk_msh.c				\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/scotch.h			\
					$(libdir)/libscotch$(LIB)		\
					$(libdir)/libscotcherrexit$(LIB)	\
					gmk_msh.h

gmk_ub2$(EXE)			:	gmk_ub2.c				\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/scotch.h			\
					$(libdir)/libscotch$(LIB)		\
					$(libdir)/libscotcherrexit$(LIB)	\
					gmk_ub2.h

gmtst$(EXE)			:	gmtst.c					\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/scotch.h			\
					$(libdir)/libscotch$(LIB)		\
					$(libdir)/libscotcherrexit$(LIB)	\
					gmtst.h

gord$(EXE)			:	gord.c					\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/scotch.h			\
					$(libdir)/libscotch$(LIB)		\
					$(libdir)/libscotcherrexit$(LIB)	\
					gord.h

gotst$(EXE)			:	gotst.c					\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/scotch.h			\
					$(libdir)/libscotch$(LIB)		\
					$(libdir)/libscotcherrexit$(LIB)	\
					gotst.h

gout$(EXE)			:	gout_c.c				\
					gout_o.c				\
					$(includedir)/scotch.h			\
					$(libdir)/libscotch$(LIB)		\
					$(libdir)/libscotcherrexit$(LIB)
					$(CC) $(CFLAGS) -I../libscotch -I$(includedir) gout_c.c gout_o.c -o $(@) -L$(libdir) -lscotch -lscotcherrexit $(LDFLAGS)

gpart$(EXE)			:	gmap.c					\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/scotch.h			\
					$(libdir)/libscotch$(LIB)		\
					$(libdir)/libscotcherrexit$(LIB)	\
					gmap.h
			 		$(CC) $(CFLAGS) -I$(includedir) -I../libscotch $(<) -DSCOTCH_COMPILE_PART -o $(@) -L$(libdir) -lscotch -lscotcherrexit $(LDFLAGS)

gscat$(EXE)			:	gscat.c					\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/scotch.h			\
					$(libdir)/libscotch$(LIB)		\
					$(libdir)/libscotcherrexit$(LIB)	\
					gscat.h

gtst$(EXE)			:	gtst.c					\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/scotch.h			\
					$(libdir)/libscotch$(LIB)		\
					$(libdir)/libscotcherrexit$(LIB)	\
					gtst.h

mcv$(EXE)			:	mcv.c					\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/scotch.h			\
					$(libdir)/libscotch$(LIB)		\
					$(libdir)/libscotcherrexit$(LIB)	\
					mcv.h

mmk_m2$(EXE)			:	mmk_m2.c				\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/scotch.h			\
					$(libdir)/libscotch$(LIB)		\
					$(libdir)/libscotcherrexit$(LIB)	\
					mmk_m2.h

mmk_m3$(EXE)			:	mmk_m3.c				\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/scotch.h			\
					$(libdir)/libscotch$(LIB)		\
					$(libdir)/libscotcherrexit$(LIB)	\
					mmk_m3.h

mord$(EXE)			:	mord.c					\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/scotch.h			\
					$(libdir)/libscotch$(LIB)		\
					$(libdir)/libscotcherrexit$(LIB)	\
					mord.h

mtst$(EXE)			:	mtst.c					\
					../libscotch/module.h			\

=== doc/src/maint/Makefile ===
## Copyright 2018,2019,2021 IPB, Universite de Bordeaux, INRIA & CNRS
##
## This file is part of the Scotch software package for static mapping,
## graph partitioning and sparse matrix ordering.
##
## This software is governed by the CeCILL-C license under French law
## and abiding by the rules of distribution of free software. You can
## use, modify and/or redistribute the software under the terms of the
## CeCILL-C license as circulated by CEA, CNRS and INRIA at the following
## URL: "http://www.cecill.info".
##
## As a counterpart to the access to the source code and rights to copy,
## modify and redistribute granted by the license, users are provided
## only with a limited warranty and the software's author, the holder of
## the economic rights, and the successive licensors have only limited
## liability.
##
## In this respect, the user's attention is drawn to the risks associated
## with loading, using, modifying and/or developing or reproducing the
## software by the user in light of its specific status of free software,
## that may mean that it is complicated to manipulate, and that also
## therefore means that it is reserved for developers and experienced
## professionals having in-depth computer knowledge. Users are therefore
## encouraged to load and test the software's suitability as regards
## their requirements in conditions enabling the security of their
## systems and/or data to be ensured and, more generally, to use and
## operate it in the same conditions as regards security.
##
## The fact that you are presently reading this means that you have had
## knowledge of the CeCILL-C license and that you accept its terms.
##

VERSION		= 6.1

MMAN		= scotch_maint$(VERSION)

FLAGS		= -sPAPERSIZE=a4

DEPS		= $(wildcard *.tex) $(wildcard *.eps)

MANS		= $(MMAN).ps.gz $(MMAN).pdf

CP		= cp -f
RM		= rm -f

.PHONY				:	clean	default	install	realclean

default				:	$(MANS)

%.eps				:	%.fig
					fig2dev -L eps $(<) $(@)

%.dvi				:	%.tex $(DEPS)
					latex $(<)
					-bibtex $(*)
					latex $(<)
					latex $(<)

%.ps				:	%.dvi
					dvips $(FLAGS) $(<)

$(MMAN).pdf			:	m.dvi
					dvipdf $(FLAGS) $(<) $(@)

$(MMAN).ps.gz			:	m.ps
					gzip -9 -c < $(<) > $(@)

install				:	$(MANS)
					-$(CP) $(MMAN).ps.gz ../../
					-$(CP) $(MMAN).pdf ../../

clean				:
					-$(RM) *~ m.aux m.blg m.log m.toc

realclean			:	clean
					-$(RM) *~ m.bbl *dvi m.ps $(MMAN)*

=== doc/src/scotch/Makefile ===
## Copyright 2018,2019,2021 IPB, Universite de Bordeaux, INRIA & CNRS
##
## This file is part of the Scotch software package for static mapping,
## graph partitioning and sparse matrix ordering.
##
## This software is governed by the CeCILL-C license under French law
## and abiding by the rules of distribution of free software. You can
## use, modify and/or redistribute the software under the terms of the
## CeCILL-C license as circulated by CEA, CNRS and INRIA at the following
## URL: "http://www.cecill.info".
## 
## As a counterpart to the access to the source code and rights to copy,
## modify and redistribute granted by the license, users are provided
## only with a limited warranty and the software's author, the holder of
## the economic rights, and the successive licensors have only limited
## liability.
## 
## In this respect, the user's attention is drawn to the risks associated
## with loading, using, modifying and/or developing or reproducing the
## software by the user in light of its specific status of free software,
## that may mean that it is complicated to manipulate, and that also
## therefore means that it is reserved for developers and experienced
## professionals having in-depth computer knowledge. Users are therefore
## encouraged to load and test the software's suitability as regards
## their requirements in conditions enabling the security of their
## systems and/or data to be ensured and, more generally, to use and
## operate it in the same conditions as regards security.
## 
## The fact that you are presently reading this means that you have had
## knowledge of the CeCILL-C license and that you accept its terms.
##

VERSION		= 6.1

UMAN		= scotch_user$(VERSION)

FLAGS		= -sPAPERSIZE=a4

DEPS		= $(wildcard *.tex) $(wildcard *.eps)

MANS		= $(UMAN).ps.gz $(UMAN).pdf

CP		= cp -f
RM		= rm -f

.PHONY				:	clean	default	install	realclean

default				:	$(MANS)

%.eps				:	%.fig
					fig2dev -L eps $(<) $(@)

%.dvi				:	%.tex $(DEPS)
					latex $(<)
					-bibtex $(*)
					latex $(<)
					latex $(<)

%.ps				:	%.dvi
					dvips $(FLAGS) $(<)

$(UMAN).pdf			:	s.dvi
					dvipdf $(FLAGS) $(<) $(@)

$(UMAN).ps.gz			:	s.ps
					gzip -9 -c < $(<) > $(@)

install				:	$(MANS)
					-$(CP) $(UMAN).ps.gz ../../
					-$(CP) $(UMAN).pdf ../../

clean				:
					-$(RM) *~ s.aux s.blg s.log s.toc

realclean			:	clean
					-$(RM) *~ s.bbl *dvi s.ps $(UMAN)*

=== debian/changelog ===
scotch (6.1.3-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.

 -- Drew Parsons <dparsons@debian.org>  Sat, 01 Jan 2022 14:45:59 +0100

scotch (6.1.1-2) unstable; urgency=medium

  * Team upload.
  * Standards-Version: 4.6.0
  * builds with Metis v5 compatibility. Closes: Bug#989783.

 -- Drew Parsons <dparsons@debian.org>  Sat, 16 Oct 2021 12:30:35 +0200

scotch (6.1.1-1exp1) experimental; urgency=medium

  * Team upload.
  * new upstream release
    - improves Metis compatibility (METIS_PartMeshDual).
      See Bug#506033.
    - adds Metis fortran support (metisf.h)
  * build libscotchmetis.so with Metis v5 compatibility
    (-DSCOTCH_METIS_VERSION=5) to match libmetis-dev more closely
    - debian patch default_metis_v5.patch sets SCOTCH_METIS_VERSION=5
      in metis.h and injects _m5 into soname for libscotchmetis.so
      since default Metis functions are now configured to v5
  * update debian/patches/build-shared-library-soname.patch to link
    libscotchmetis.so to libscotcherr.so, since metis_graph_dual.c
    and metis_graph_part_dual.c use SCOTCH_errorPrint.
    Also link with -lm for the round function.
    Likewise link libptscotchmetis.so to libptscotcherr.so.
  * Build-Depends: gfortran | fortran-compiler
    - drop Build-Depends: quilt (patches handled by debhelper)
  * update debian/watch to track gitlab.inria.fr/scotch

 -- Drew Parsons <dparsons@debian.org>  Mon, 28 Jun 2021 00:19:12 +0200

=== debian/control ===
Source: scotch
Section: math
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: "Adam C. Powell, IV" <hazelsct@debian.org>,
 Andreas Tille <tille@debian.org>
Build-Depends: debhelper-compat (= 13),
    gfortran | fortran-compiler,
    bison, flex,
    zlib1g-dev,
    libbz2-dev,
    liblzma-dev,
    chrpath,
    mpi-default-dev, mpi-default-bin
Standards-Version: 4.6.0
Vcs-Git: https://salsa.debian.org/science-team/scotch.git
Vcs-Browser: https://salsa.debian.org/science-team/scotch
Homepage: http://www.labri.fr/perso/pelegrin/scotch/

Package: scotch
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: programs and libraries for graph, mesh and hypergraph partitioning
 Its purpose is to apply graph theory, with a divide and conquer
 approach, to scientific computing problems such as graph and mesh
 partitioning, static mapping, and sparse matrix ordering, in
 application domains ranging from structural mechanics to operating
 systems or bio-chemistry.
 .
 The SCOTCH distribution is a set of programs and libraries which
 implement the static mapping and sparse matrix reordering algorithms
 developed within the SCOTCH project.
 .
 SCOTCH has many interesting features:
 .
 o Its capabilities can be used through a set of stand-alone programs
 as well as through the libSCOTCH library, which offers both C and
 Fortran interfaces.
 .
 o It provides algorithms to partition graph structures, as well as
 mesh structures defined as node-element bipartite graphs and which
 can also represent hypergraphs.
 .
 o It can map any weighted source graph onto any weighted target
 graph. The source and target graphs may have any topology, and their
 vertices and edges may be weighted. Moreover, both source and target
 graphs may be disconnected. This feature allows for the mapping of
 programs onto disconnected subparts of a parallel architecture made
 up of heterogeneous processors and communication links.
 .
 o It computes amalgamated block orderings of sparse matrices, for
 efficient solving using BLAS routines.
 .
 o Its running time is linear in the number of edges of the source
 graph, and logarithmic in the number of vertices of the target graph
 for mapping computations.
 .
 o It can handle indifferently graph and mesh data structures created
 within C or Fortran programs, with array indices starting from 0 or
 1.
 .
 o It offers extended support for adaptive graphs and meshes through
 the handling of disjoint edge arrays.
 .
 o It is dynamically parametrizable thanks to strategy strings that
 are interpreted at run-time.
 .
 o It uses system memory efficiently, to process large graphs and
 meshes without incurring out-of-memory faults;
 .
 o It is highly modular and documented. Since it has been released
 under the CeCILL-C free/libre software license, it can be used as a
 testbed for the easy and quick development and testing of new
 partitioning and ordering methods.
 .
 o It can be easily interfaced to other programs. The programs
 comprising the SCOTCH project have been designed to run in
 command-line mode without any interactive prompting, so that they can
 be called easily from other programs by means of system() or popen()
 calls, or piped together on a single command line. Moreover, vertex
 labeling capabilities allow for easy renumbering of vertices.
 .
 o It provides many tools to build, check, and display graphs, meshes
 and matrix patterns.
 .
 o It is written in C and uses the POSIX interface, which makes it
 highly portable. PT-SCOTCH uses the MPI interface, and optionally the
 POSIX threads.

Package: ptscotch
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: MPI programs and libraries for graph, mesh and hypergraph partitioning
 PT-SCOTCH is the MPI version of scotch, which is a set of programs and
 libraries which implement the static mapping and sparse matrix reordering
 algorithms developed within the SCOTCH project.

Package: libscotch-dev
Section: libdevel
Architecture: any
Depends: libscotch-6.1 (= ${binary:Version}), mpi-default-dev, zlib1g-dev, ${shlibs:Depends}, ${misc:Depends}
Description: programs and libraries for graph, mesh and hypergraph partitioning
 Headers and libraries package for scotch, which is a set of programs and
 libraries which implement the static mapping and sparse matrix reordering
 algorithms developed within the SCOTCH project.

Package: libptscotch-dev
Section: libdevel
Architecture: any
Depends: libptscotch-6.1 (= ${binary:Version}), libscotch-dev (= ${binary:Version}), mpi-default-dev, zlib1g-dev, ${misc:Depends}
Description: MPI programs and libraries for graph, mesh and hypergraph partitioning
 Headers and libraries package for PT-SCOTCH, the MPI version of scotch, which
 is a set of programs and libraries which implement the static mapping and
 sparse matrix reordering algorithms developed within the SCOTCH project.

Package: libscotchmetis-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libscotch-dev (= ${binary:Version}), ${misc:Depends}
Conflicts: libmetis-dev, libparmetis-dev
Replaces: libmetis-dev
Description: programs and libraries for graph, mesh and hypergraph partitioning
 Scotch/Metis compatility interface, providing a free implementation of the
 Metis system for graph partitioning and sparse matrix reordering.

Package: libscotchparmetis-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libptscotch-dev (= ${binary:Version}), ${misc:Depends}
Conflicts: libparmetis-dev
Replaces: libparmetis-dev
Description: programs and libraries for graph, mesh and hypergraph partitioning
 Scotch/ParMetis compatility interface, providing a free implementation of the
 ParMetis system for parallel graph partitioning and sparse matrix reordering.

Package: libscotch-6.1
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: programs and libraries for graph, mesh and hypergraph partitioning
 Shared libraries package for scotch, which is a set of programs and
 libraries which implement the static mapping and sparse matrix reordering
 algorithms developed within the SCOTCH project.

Package: libptscotch-6.1
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: MPI programs and libraries for graph, mesh and hypergraph partitioning
 Shared libraries package for PT-SCOTCH, the MPI version of scotch, which
 is a set of programs and libraries which implement the static mapping and
 sparse matrix reordering algorithms developed within the SCOTCH project.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode. 
#export DH_VERBOSE=1


DEB_BUILD_ARCH_OS ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH_OS)
DEB_BUILD_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
DEB_HOST_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

# Disabled because this FTBFS with multiple jobs (bug 620973)
#ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
#         NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
#         MAKEFLAGS += -j$(NUMJOBS)
#endif

# Add here any variable or target overrides you need.
# where sources are
DEB_SRCDIR = $(CURDIR)/src

# no check for this software
#DEB_MAKE_CHECK_TARGET :=

# note that debian patch default_metis_v5.patch
# has set metis version compatibility to 5
# (SCOTCH_METIS_VERSION=5) in metis.h (library_metis.h),
# equivalent to configuring the build with -DSCOTCH_METIS_VERSION=5

CCP=mpicc
export CFLAGS_COMMON = -O3 -fPIC -I. \
			-Drestrict=__restrict \
			-DCOMMON_FILE_COMPRESS_GZ \
			-DCOMMON_FILE_COMPRESS_BZ2 \
			-DCOMMON_FILE_COMPRESS_LZMA \
			-DCOMMON_PTHREAD \
			-DSCOTCH_PTHREAD_NUMBER=2 \
			-DCOMMON_RANDOM_FIXED_SEED \
			-DSCOTCH_RENAME -DSCOTCH_RENAME_PARSER \
			$(shell dpkg-buildflags --get CFLAGS)
export LDFLAGS_COMMON = -pthread -lz -lbz2 -llzma -lm -lrt $(shell dpkg-buildflags --get LDFLAGS)

# hurd does not have POSIX time and therefore needs sys/time.h to define struct timeval
# hurd does not support pthread_setaffinity_np (-DSCOTCH_PTHREAD_AFFINITY_LINUX)
ifeq ($(DEB_BUILD_ARCH_OS),hurd)
  CFLAGS_COMMON += -DHAVE_SYS_TIME_H
else
  CFLAGS_COMMON += -DCOMMON_PTHREAD_AFFINITY_LINUX
endif

# By default, halt on test (check) failures. But,
# - hurd times out on buildd during build-time checks
# - m68k segfaults inside the qemu emulator used for builds
# - powerpcspe segfaults on test_scotch_graph_order in INTSIZE64
# so don't halt on test failures on these arches.
# In fact don't run tests at all on hurd.
ifeq ($(DEB_HOST_ARCH_OS),hurd)
  HALT_ON_TEST_ERROR = no
  SKIP_TESTS = yes
else ifeq ($(DEB_HOST_ARCH),m68k)
  HALT_ON_TEST_ERROR = no
else ifeq ($(DEB_HOST_ARCH),powerpcspe)
  HALT_ON_TEST_ERROR = no
else
  HALT_ON_TEST_ERROR = yes
endif
ifeq (nocheck,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
  SKIP_TESTS = yes
endif


DEB_DBG_PACKAGE_scotch = scotch-dbg
DEB_DBG_PACKAGE_ptscotch = ptscotch-dbg
DEB_DBG_PACKAGE_libscotch-6.1 = libscotch-dbg
DEB_DBG_PACKAGE_libptscotch-6.1 = libptscotch-dbg

DEB_STRIPPED_UPSTREAM_VERSION = $(shell echo $(DEB_UPSTREAM_VERSION) | sed -n -e 's/\.dfsg.*$$//p')
SCOTCH_VERSION=$(DEB_STRIPPED_UPSTREAM_VERSION)

INTSIZE_VERS := $(shell echo "int int32 int64 long")

export OMPI_MCA_plm_rsh_agent=/bin/false                #workaround to start MPI-applications in chroot

%:
	dh $@

override_dh_auto_build:
	for v in $(INTSIZE_VERS); do \
	   mkdir -p $(CURDIR)/$$v; \
	   mkdir -p $(CURDIR)/$$v/bin; \
	   mkdir -p $(CURDIR)/$$v/lib; \
	   mkdir -p $(CURDIR)/$$v/include; \
	   mkdir -p $(CURDIR)/$$v/share/man/man1; \
	done
	set -e; \
	for v in $(INTSIZE_VERS); do \
	   echo "compiling for $$v"; \
	   cp debian/Makefile_$$v.inc src/Makefile.inc; \
	   (cd src && $(MAKE) realclean prefix=$(CURDIR)/$$v); \
	   (cd src && $(MAKE) scotch ptscotch prefix=$(CURDIR)/$$v); \
	   (cd src && $(MAKE) esmumps ptesmumps prefix=$(CURDIR)/$$v); \
	   echo "check for $$v"; \
	   if [ "x$(SKIP_TESTS)" != "xyes" ]; then \
	     if [ "x$(HALT_ON_TEST_ERROR)" = "xno" ]; then \
	       (cd src && LD_LIBRARY_PATH=$(CURDIR)/src/check/../../lib:$(LD_LIBRARY_PATH) $(MAKE) check prefix=$(CURDIR)/$$v) || /bin/true; \
	     else \
	       (cd src && LD_LIBRARY_PATH=$(CURDIR)/src/check/../../lib:$(LD_LIBRARY_PATH) $(MAKE) check prefix=$(CURDIR)/$$v); \
	     fi; \
	   fi; \
	   echo "install for $$v"; \
	   (cd src && $(MAKE) install prefix=$(CURDIR)/$$v); \
	   mv $$v/bin/gbase $$v/bin/scotch_gbase; \
	   mv $$v/bin/gmap $$v/bin/scotch_gmap; \
	   mv $$v/bin/gpart $$v/bin/scotch_gpart; \
	   rm -rf lib; \
	   rm -f src/Makefile.inc; \
	done

override_dh_auto_install:
#	find . -name libscotch.so | xargs ls -l; \
#	Install [par]metis-compatibility symlinks
	for v in $(INTSIZE_VERS); do \
	   (cd $$v/lib && ln -s libscotchmetis.a libmetis.a); \
	   (cd $$v/lib && ln -s libscotchmetis.so libmetis.so); \
	   (cd $$v/lib && ln -s libptscotchparmetis.a libparmetis.a); \
	   (cd $$v/lib && ln -s libptscotchparmetis.so libparmetis.so); \
	done

#	add suffix to {int32,int64,long}/bin/*
	for file in $(shell ls int32/bin); do \
	   (cd int32/bin && mv $$file $$file-int32); \
	done
	for file in $(shell ls int64/bin); do \
	   (cd int64/bin && mv $$file $$file-int64); \
	done
	for file in $(shell ls long/bin); do \
	   (cd long/bin && mv $$file $$file-long); \
	done
#       Add "#include <cstdio>" to main [pt]scotch.h
	find . -name \*scotch.h | xargs perl -pi -e "s|\/\*\+ Version flags|\#ifdef \_\_cplusplus\n\#include \<cstdio\>\n\#else\n\#include \<stdio.h\>\n\#endif\n\n\/\*\+ Version flags|"


override_dh_installman:
	dh_installman
	mv debian/scotch/usr/share/man/man1/gmap.1 debian/scotch/usr/share/man/man1/scotch_gmap.1
	mv debian/scotch/usr/share/man/man1/gbase.1 debian/scotch/usr/share/man/man1/scotch_gbase.1
	(cd debian/scotch/usr/share/man/man1 && ln -sf scotch_gmap.1.gz scotch_gpart.1.gz)
	for file in $(shell ls int/bin); do \
	  if [ -x debian/scotch/usr/bin/$$file ]; then \
	    (cd debian/scotch/usr/share/man/man1 && ln -sf $$file.1.gz $$file-int32.1.gz); \
	    (cd debian/scotch/usr/share/man/man1 && ln -sf $$file.1.gz $$file-int64.1.gz); \
	    (cd debian/scotch/usr/share/man/man1 && ln -sf $$file.1.gz $$file-long.1.gz); \
	  fi; \
	  if [ -x debian/ptscotch/usr/bin/$$file ]; then \
	    (cd debian/ptscotch/usr/share/man/man1 && ln -sf $$file.1.gz $$file-int32.1.gz); \
	    (cd debian/ptscotch/usr/share/man/man1 && ln -sf $$file.1.gz $$file-int64.1.gz); \
	    (cd debian/ptscotch/usr/share/man/man1 && ln -sf $$file.1.gz $$file-long.1.gz); \
	  fi; \
	done


override_dh_clean:
	dh_clean
	for v in $(INTSIZE_VERS); do \
	   (if [ -d $$v ]; then rm -rf $$v; fi); \
	done
	cp debian/Makefile.inc src/
	make -C src/check realclean
	make -C src realclean
	rm -f src/Makefile.inc
